#include <bits/stdc++.h>
#define pb push_back
#define all(x) begin(x),end(x)
#define PRINT(x) cerr<<#x<<'='<<x<<endl
#define fi first
#define se second
#define wgross 0.05
#define wnet 0.2
#define delta 0.15
#define INF 1000000000
using namespace std;
#define MAXN 3000
struct ug{
    bool tip; ///0 - asset 1 - deposit
    int idx;
    double val, in;
    ug() { tip = idx = val = in = 0; }
    ug(bool _tip, int _idx, double _val, double _in) { tip = _tip, idx = _idx, val = _val, in = _in; }
};
vector<ug> v, b[MAXN];
int C = 0, R[MAXN];
bool cmpIn(ug A, ug B) {
    return A.in <= B.in;
}
void cluster() {
    for(auto x : v) {
        PRINT(x.in);
    }
    while(!v.empty()) {
        C++;
        int maxx = -INF, maxi = 0;
        for(int i = 0; i < v.size(); i++) {
            int j;
            for(j = i; j < v.size(); j++) {
                if(v[i].in+delta < v[j].in) break;
            }
            if(j-i >= maxx) {
                maxx = j-i;
                maxi = i;
            }
        }
        for(int i = maxi; i < v.size(); i++) {
            if(v[maxi].in+delta < v[i].in) break;
            if(v[i].idx == 20 || v[i].idx == 85) {
                PRINT(v[i].idx);
                PRINT(C);
            }
            b[C].pb(v[i]);
        }
        v.erase(v.begin()+maxi, v.begin()+maxi+maxx);
    }
}
set<pair<double, int> > as, dp;
pair<double,int> smaller(set<pair<double,int> > &A, pair<double,int> gr) {
    auto x = A.lower_bound(gr);
    if(x == A.begin()) return {-1, -1};
    x--;
    A.erase(x);
    return *x;
}
double zebra(set<pair<double, int> > &A, set<pair<double, int> > &B, int Z) {
    double sum = 0;
    pair<double, int> gr = {1000000000000000LL, 0};
    while(1) {
        pair<double, int> p = smaller(A, gr);
        if(p.fi < 0) return sum;
        sum += p.fi;
        R[p.se] = Z;
        gr = p;

        p  = smaller(B, gr);
        if(p.fi < 0) return sum;
        sum -= p.fi;
        R[p.se] = Z;
        gr = p;
    }
    return sum;
}
int Z = 0;
pair<double, double> solve(vector<ug> &v) {
    as.clear(); dp.clear();
    for(int i = 0; i < v.size(); i++) {
        if(v[i].tip == 0) as.insert({v[i].val, v[i].idx});
        if(v[i].tip == 1) dp.insert({v[i].val, v[i].idx});
    }
    double A = 0, L = 0;
    while(!as.empty() || !dp.empty()) {
        A += zebra(as, dp, ++Z);
        L += zebra(dp, as, ++Z);
    }
    PRINT(A);
    PRINT(L);
    return {A, L};
}
int main() {
    ios::sync_with_stdio(false); cin.tie(0); cout.tie(0); cerr.tie(0);
    freopen("tier1.txt", "r", stdin);
    freopen("out1.txt", "w", stdout);
    double A, L, in;
    string x;
    int idx = 0;
    while(cin >> A >> L >> x >> in) {
        bool tip;
        ++idx;
        if(idx == 1) {
            PRINT(A);
            PRINT(L);
            PRINT(x);
            PRINT(in);
        }
        if(A <= 1e-6) tip = 1;
        if(L <= 1e-6) tip = 0;
        double val = A+L;
        v.push_back(ug(tip, idx, val, in));
    }
    sort(all(v), cmpIn);
    cluster();
    A = L = 0;
    for(int c = 1; c <= C; c++) {
        PRINT(b[c].size());
        pair<double, double> rez = solve(b[c]);
        A += rez.fi, L += rez.se;
    }
    double rez = (A+L)*wgross + fabs(A-L)*wnet;
    cout << fixed << rez << endl;
    for(int i = 1; i <= idx; i++) {
        cout << R[i] << endl;
    }
    return 0;
}
