#include <bits/stdc++.h>
#define pb push_back
#define all(x) begin(x),end(x)
#define PRINT(x) cerr<<#x<<'='<<x<<endl
#define fi first
#define se second
#define wgross 0.1
#define wnet 0.4
#define delta 0.15
#define days 30
#define INF 1000000000
using namespace std;
#define MAXN 3000
struct ug{
    bool tip; ///0 - asset 1 - deposit
    int idx, dat;
    double val, in;
    ug() { tip = idx = val = in = dat = 0; }
    ug(bool _tip, int _idx, double _val, int _dat, double _in) { tip = _tip, idx = _idx, val = _val, dat = _dat, in = _in; }
};
vector<ug> v, b[MAXN];
int C = 0, R[MAXN];
bool cmpIn(ug A, ug B) {
    return A.in <= B.in;
}
vector<ug> v1;
void cluster() {
    while(!v.empty()) {
        C++;
        v1.clear();
        int maxx = -INF, maxi = 0;
        for(int i = 0; i < v.size(); i++) {
            int cnt = 0;
            for(int j = 0; j < v.size(); j++) {
                if(v[i].in+delta >= v[j].in && v[i].dat+days >= v[j].dat && v[j].in >= v[i].in && v[j].dat >= v[i].dat) cnt++;
            }
            if(cnt >= maxx) {
                maxx = cnt;
                maxi = i;
            }
        }
        for(int i = 0; i < v.size(); i++) {
            if(v[maxi].in+delta >= v[i].in && v[maxi].dat+days >= v[i].dat && v[i].in >= v[maxi].in && v[i].dat >= v[maxi].dat) {
                b[C].pb(v[i]);
            } else {
                v1.pb(v[i]);
            }
        }
        PRINT(C);
        PRINT(maxx);
        v = v1;
    }
}
set<pair<double, int> > as, dp;
pair<double,int> smaller(set<pair<double,int> > &A, pair<double,int> gr) {
    auto x = A.lower_bound(gr);
    if(x == A.begin()) return {-1, -1};
    x--;
    A.erase(x);
    return *x;
}
double zebra(set<pair<double, int> > &A, set<pair<double, int> > &B, int Z) {
    double sum = 0;
    pair<double, int> gr = {1000000000000000LL, 0};
    while(1) {
        pair<double, int> p = smaller(A, gr);
        if(p.fi < 0) return sum;
        sum += p.fi;
        R[p.se] = Z;
        gr = p;

        p  = smaller(B, gr);
        if(p.fi < 0) return sum;
        sum -= p.fi;
        R[p.se] = Z;
        gr = p;
    }
    return sum;
}
int Z = 0;
pair<double, double> solve(vector<ug> &v) {
    as.clear(); dp.clear();
    for(int i = 0; i < v.size(); i++) {
        if(v[i].tip == 0) as.insert({v[i].val, v[i].idx});
        if(v[i].tip == 1) dp.insert({v[i].val, v[i].idx});
    }
    double A = 0, L = 0;
    while(!as.empty() || !dp.empty()) {
        A += zebra(as, dp, ++Z);
        L += zebra(dp, as, ++Z);
    }
    PRINT(A);
    PRINT(L);
    return {A, L};
}
int main() {
    ios::sync_with_stdio(false); cin.tie(0); cout.tie(0); cerr.tie(0);
    freopen("tier2.txt", "r", stdin);
    freopen("out2.txt", "w", stdout);
    double A, L, in;
    string x;
    int idx = 0, dat;
    while(cin >> A >> L >> x >> dat >> in) {
        bool tip;
        ++idx;
        if(A <= 1e-6) tip = 1;
        if(L <= 1e-6) tip = 0;
        double val = A+L;
        v.push_back(ug(tip, idx, val, dat, in));
    }
    sort(all(v), cmpIn);
    cluster();
    A = L = 0;
    for(int c = 1; c <= C; c++) {
        PRINT(b[c].size());
        pair<double, double> rez = solve(b[c]);
        A += rez.fi, L += rez.se;
    }
    double rez = (A+L)*wgross + fabs(A-L)*wnet;
    cout << fixed << rez << endl;
    for(int i = 1; i <= idx; i++) {
        cout << R[i] << endl;
    }
    return 0;
}
